/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.deepexi.scd.calculate.domain.vo.CalculateLayoutFacilityDataFillVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateLayoutFacilityMonthVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemValueVO
 *  com.deepexi.scd.calculate.domain.vo.report.ExportReportLayoutVO
 *  com.deepexi.scd.calculate.domain.vo.word.facility.CalculateDetectDataReportVO
 *  com.deepexi.scd.calculate.service.TemplateService
 *  com.deepexi.scd.calculate.util.Calculator
 *  com.deepexi.scd.calculate.util.DataCollectors
 *  com.deepexi.scd.common.enums.business.AnalysisValueTypeEnum
 *  com.deepexi.scd.common.enums.business.CalculateItemValueTypeEnum
 *  com.deepexi.scd.common.enums.business.CalculateStandardFieldValueTypeEnum
 *  com.deepexi.scd.common.extensions.ExNumeric
 *  com.deepexi.spa.commons.utils.CollectionUtils
 *  com.deepexi.spa.commons.utils.StringUtils
 */
package com.deepexi.scd.calculate.service.impl.report;

import com.deepexi.scd.calculate.domain.vo.CalculateLayoutFacilityDataFillVO;
import com.deepexi.scd.calculate.domain.vo.CalculateLayoutFacilityMonthVO;
import com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemVO;
import com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemValueVO;
import com.deepexi.scd.calculate.domain.vo.report.ExportReportLayoutVO;
import com.deepexi.scd.calculate.domain.vo.word.facility.CalculateDetectDataReportVO;
import com.deepexi.scd.calculate.service.TemplateService;
import com.deepexi.scd.calculate.util.Calculator;
import com.deepexi.scd.calculate.util.DataCollectors;
import com.deepexi.scd.common.enums.business.AnalysisValueTypeEnum;
import com.deepexi.scd.common.enums.business.CalculateItemValueTypeEnum;
import com.deepexi.scd.common.enums.business.CalculateStandardFieldValueTypeEnum;
import com.deepexi.scd.common.extensions.ExNumeric;
import com.deepexi.spa.commons.utils.CollectionUtils;
import com.google.common.collect.ImmutableMap;
import com.google.common.collect.Maps;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Optional;
import java.util.Set;
import java.util.stream.Collectors;
import org.apache.commons.lang3.StringUtils;

public abstract class AbstractTemplateService
implements TemplateService {
    protected static final String FOSSIL_CONSUMPTION_VALUE = "消耗量(真实值)";
    protected static final String FOSSIL_AVG_LOW_VALUE = "平均低位发热量";
    protected static final String FOSSIL_AVG_LOW_WEIGHT_VALUE = "平均低位发热量(真实值)";
    protected static final String FOSSIL_UNIT_HOT_CAR_VALUE = "单位热值含碳量";
    protected static final String FOSSIL_UNIT_HOT_CAR_WEIGHT_VALUE = "单位热值含碳量(真实值)";
    protected static final String FOSSIL_REC_CAR_ELE_VALUE = "收到基元素碳含量";
    protected static final String FOSSIL_REC_CAR_ELE_WEIGHT_VALUE = "收到基元素碳含量(加权平均值)";
    protected static final String PROD_RUN_HOURS_VALUE = "运行小时数(真实值)";
    protected static final String PROD_LOAD_COEF_VALUE = "负荷（出力）系数";
    protected static final String PROD_LOAD_COEF_WEIGHT_VALUE = "负荷（出力）系数(真实值)";
    protected static final String CREW_C02_EMISS = "机组二氧化碳排放量";
    protected static final String ALL_CREW_CO2_EMISS = "全部机组二氧化碳排放总量";
    protected static final String CREW_ZTX_TITLE = "总体信息";
    protected static final String CREW_TYPE_FIELD = "发电燃料类型";
    protected static final String UNIT_TYPE_FIELD = "机组类型";
    protected static final String UNIT_TYPE_FIELD_DETAIL = "机组类型细分";
    protected static final String ZJRL_FIELD = "装机容量（MW）";
    protected static final String XHJZ_FIELD = "是否循环流化床机组";
    protected static final String IGCC_FIELD = "是否IGCC机组";
    protected static final String RLMC_FIELD = "燃料名称";
    protected static final String XHJZ = "循环流化床机组";
    protected static final String IGCC = "IGCC机组";
    protected static final String MERGE_REPORT_NAME = "合并填报";
    protected static final Map<String, Integer> ENERGY_CATEGORY_SORT = ImmutableMap.of("COAL", 1, "OIL", 2, "ELECTRICITY", 3, "GAS", 4, "HEAT", 5);

    public Map<String, String> getItemSumMap(List<CalculateLayoutItemVO> itemVOList) {
        HashMap<String, String> resultMap = new HashMap<String, String>();
        if (CollectionUtils.isNotEmpty(itemVOList)) {
            List itemValueList = itemVOList.stream().flatMap(f -> f.getItemValueList().stream()).collect(Collectors.toList());
            List computeItemValueSumList = itemValueList.stream().filter(f -> this.getComputeValueTypeSumList().contains(f.getValueType())).collect(Collectors.toList());
            Map sumMap = DataCollectors.getSum(computeItemValueSumList, CalculateLayoutItemValueVO::getValueCode, m -> ExNumeric.toBigDecimal((String)m.getValue()));
            List computeItemValueArgList = itemValueList.stream().filter(f -> this.getComputeValueTypeArgList().contains(f.getValueType())).collect(Collectors.toList());
            Map itemValueSizeMap = DataCollectors.groupingBy(computeItemValueArgList, CalculateLayoutItemValueVO::getValueCode);
            for (Map.Entry entry : sumMap.entrySet()) {
                List layoutItemValueVOS = (List)itemValueSizeMap.get(entry.getKey());
                if (CollectionUtils.isNotEmpty((Collection)layoutItemValueVOS)) {
                    int valueSize = layoutItemValueVOS.size();
                    resultMap.put((String)entry.getKey(), ExNumeric.formatValue((BigDecimal)((BigDecimal)entry.getValue()).divide(new BigDecimal(valueSize), 10, 4), (Integer)10));
                    continue;
                }
                resultMap.put((String)entry.getKey(), ExNumeric.formatValue((BigDecimal)((BigDecimal)entry.getValue()), (Integer)10));
            }
        }
        return resultMap;
    }

    public String getItemValue(Map<String, BigDecimal> computeItemValueSumMap, String valueType, String valueCode, String value, int valueSize) {
        if (CalculateItemValueTypeEnum.CONSUMPTION.getKey().equals(valueType)) {
            return computeItemValueSumMap.get(valueCode).toString();
        }
        if (CalculateItemValueTypeEnum.FACTOR.getKey().equals(valueType)) {
            return computeItemValueSumMap.get(valueCode).divide(new BigDecimal(valueSize), 10, 4).toString();
        }
        return value;
    }

    private List<String> getComputeValueTypeSumList() {
        return Arrays.asList(CalculateItemValueTypeEnum.CONSUMPTION.getKey(), CalculateItemValueTypeEnum.FACTOR.getKey());
    }

    private List<String> getComputeValueTypeArgList() {
        return Arrays.asList(CalculateItemValueTypeEnum.FACTOR.getKey());
    }

    protected BigDecimal getMonthWholeDataList(List<Map<String, String>> wholeDataList, Map<String, List<CalculateLayoutItemVO>> monthMap, String month, LinkedHashMap<String, ColumnParam> columnParamMap) {
        BigDecimal reVal = BigDecimal.ZERO;
        List<CalculateLayoutItemVO> itemVOList = monthMap.get(month);
        if (CollectionUtils.isEmpty(itemVOList)) {
            HashMap<String, String> itemVOMap = new HashMap<String, String>();
            for (Map.Entry<String, ColumnParam> entry : columnParamMap.entrySet()) {
                itemVOMap.put(entry.getKey(), "");
                if (Arrays.asList("消耗量", FOSSIL_UNIT_HOT_CAR_VALUE, FOSSIL_AVG_LOW_VALUE).contains(entry.getKey())) {
                    itemVOMap.put(entry.getKey() + "(真实值)", "");
                }
                if (!Arrays.asList(FOSSIL_REC_CAR_ELE_VALUE).contains(entry.getKey())) continue;
                itemVOMap.put(FOSSIL_REC_CAR_ELE_WEIGHT_VALUE, "");
            }
            wholeDataList.add(itemVOMap);
        } else {
            Map<String, String> itemSumMap = this.getItemSumMap(itemVOList);
            HashMap<String, String> itemVOMap = new HashMap<String, String>();
            for (Map.Entry<String, ColumnParam> entry : columnParamMap.entrySet()) {
                BigDecimal value;
                String formatValue = "0";
                ColumnParam columnParam = entry.getValue();
                String formula = columnParam.getFormula();
                Integer scale = columnParam.getScale();
                boolean isRounding = columnParam.isRounding;
                if (Objects.nonNull(formula)) {
                    value = Calculator.conversion((String)formula, itemSumMap, (Integer)scale, (boolean)isRounding);
                    formatValue = ExNumeric.formatValue((BigDecimal)value);
                } else {
                    formatValue = itemSumMap.get(entry.getKey());
                }
                if (Objects.nonNull(scale)) {
                    formatValue = isRounding ? ExNumeric.formatValue((String)formatValue, (Integer)scale) : ExNumeric.formatValue((String)formatValue, (Integer)scale, (RoundingMode)RoundingMode.DOWN);
                }
                itemVOMap.put(entry.getKey(), formatValue);
                if (Arrays.asList("化石燃料燃烧排放量", "购入电力排放量").contains(entry.getKey())) {
                    BigDecimal sumValue = DataCollectors.getSum(itemVOList, m -> m.getTotalValue());
                    if (Objects.nonNull(scale)) {
                        formatValue = isRounding ? ExNumeric.formatValue((BigDecimal)sumValue, (Integer)scale) : ExNumeric.formatValue((BigDecimal)sumValue, (Integer)scale, (RoundingMode)RoundingMode.DOWN);
                    }
                    itemVOMap.put(entry.getKey(), formatValue);
                    reVal = ExNumeric.toBigDecimal((String)formatValue);
                }
                if (Arrays.asList("消耗量", FOSSIL_UNIT_HOT_CAR_VALUE, FOSSIL_AVG_LOW_VALUE).contains(entry.getKey())) {
                    itemVOMap.put(entry.getKey() + "(真实值)", itemSumMap.get(entry.getKey()));
                }
                if (!Arrays.asList(FOSSIL_REC_CAR_ELE_VALUE).contains(entry.getKey())) continue;
                if (Objects.nonNull(formula)) {
                    value = Calculator.conversion((String)formula, itemSumMap, (Integer)10);
                    itemVOMap.put(FOSSIL_REC_CAR_ELE_WEIGHT_VALUE, ExNumeric.formatValue((BigDecimal)value));
                    continue;
                }
                itemVOMap.put(FOSSIL_REC_CAR_ELE_WEIGHT_VALUE, itemSumMap.get(entry.getKey()));
            }
            wholeDataList.add(itemVOMap);
        }
        return reVal;
    }

    protected Map<String, String> getProdDataItemSumMap(List<CalculateLayoutItemVO> itemVOList) {
        Map<String, String> resultMap = new HashMap<String, String>();
        if (CollectionUtils.isNotEmpty(itemVOList)) {
            List itemValueList = itemVOList.stream().flatMap(f -> f.getItemValueList().stream()).collect(Collectors.toList());
            itemValueList = itemValueList.stream().filter(f -> !CalculateStandardFieldValueTypeEnum.FIX.getCode().equals(f.getValueScalarType())).collect(Collectors.toList());
            resultMap = itemValueList.stream().collect(Collectors.toMap(CalculateLayoutItemValueVO::getValueCode, CalculateLayoutItemValueVO::getValue));
        }
        return resultMap;
    }

    protected String getSumOrAvgValue(List<String> monthValueList, ColumnParam columnParam) {
        BigDecimal totalValue = BigDecimal.ZERO;
        if (CollectionUtils.isNotEmpty(monthValueList = monthValueList.stream().filter(StringUtils::isNotBlank).filter(f -> !f.equals("0")).collect(Collectors.toList()))) {
            totalValue = DataCollectors.getSum(monthValueList, v -> ExNumeric.toBigDecimal((String)v));
            if (columnParam.isAvg) {
                totalValue = totalValue.divide(new BigDecimal(monthValueList.size()), 10, 4);
            }
        }
        String totalValueStr = ExNumeric.formatValue((BigDecimal)totalValue, (Integer)10);
        Integer scale = columnParam.getScale();
        boolean isRounding = columnParam.isRounding;
        if (Objects.nonNull(scale)) {
            totalValueStr = isRounding ? ExNumeric.formatValue((String)totalValueStr, (Integer)scale) : ExNumeric.formatValue((String)totalValueStr, (Integer)scale, (RoundingMode)RoundingMode.DOWN);
        }
        return totalValueStr;
    }

    protected Map<String, Set<String>> getFacilityEnergyCategoryMap(ExportReportLayoutVO exportReportLayoutVO) {
        List facilityList = exportReportLayoutVO.getFacilityList();
        HashMap<String, Set<String>> fossilFuelEnergyCategoryMap = new HashMap<String, Set<String>>();
        for (CalculateLayoutFacilityDataFillVO facilityDataFillVO : facilityList) {
            List facilityMonthList = facilityDataFillVO.getFacilityMonthList();
            Set allFacilityEnergyTypeSet = new HashSet();
            LinkedHashMap sortMap = Maps.newLinkedHashMap();
            if (CollectionUtils.isNotEmpty((Collection)facilityMonthList)) {
                for (CalculateLayoutFacilityMonthVO facilityMonth : facilityMonthList) {
                    List fossilFuelItemVOS = facilityMonth.getCalculateLayoutItemVOS().stream().filter(f -> com.deepexi.spa.commons.utils.StringUtils.containsAny((CharSequence)f.getTableName(), (CharSequence)AnalysisValueTypeEnum.FOSSIL_ENERGY.getValue())).collect(Collectors.toList());
                    if (CollectionUtils.isEmpty(fossilFuelItemVOS)) continue;
                    fossilFuelItemVOS.stream().filter(item -> CollectionUtils.isNotEmpty((Collection)item.getItemValueList())).forEach(item -> {
                        Optional<CalculateLayoutItemValueVO> itemOptional = item.getItemValueList().stream().filter(f -> CalculateItemValueTypeEnum.CALCULATE_ITEM.getKey().equals(f.getValueType())).findFirst();
                        Optional<CalculateLayoutItemValueVO> itemCategoryOptional = item.getItemValueList().stream().filter(f -> CalculateItemValueTypeEnum.ENERGY_CATEGORY.getKey().equals(f.getValueType())).findFirst();
                        if (!itemOptional.isPresent()) {
                            return;
                        }
                        Integer sort = itemCategoryOptional.isPresent() ? ENERGY_CATEGORY_SORT.getOrDefault(itemCategoryOptional.get().getValue(), Integer.MAX_VALUE) : Integer.valueOf(Integer.MAX_VALUE);
                        sortMap.put(itemOptional.get().getValue(), sort);
                    });
                }
            }
            if (CollectionUtils.isNotEmpty(sortMap.keySet())) {
                allFacilityEnergyTypeSet = sortMap.keySet().stream().sorted((o1, o2) -> {
                    Integer front = (Integer)sortMap.get(o1);
                    Integer end = (Integer)sortMap.get(o2);
                    return front - end;
                }).collect(Collectors.toCollection(LinkedHashSet::new));
            }
            String facilityName = facilityDataFillVO.getFacilityId() == 0L ? "" : facilityDataFillVO.getFacilityId() + "";
            fossilFuelEnergyCategoryMap.put(facilityName, allFacilityEnergyTypeSet);
        }
        return fossilFuelEnergyCategoryMap;
    }

    protected boolean checkFieldLegal(CalculateDetectDataReportVO vo) {
        if (com.deepexi.spa.commons.utils.StringUtils.isNotBlank((CharSequence)vo.getSelfValue1())) {
            return false;
        }
        if (com.deepexi.spa.commons.utils.StringUtils.isNotBlank((CharSequence)vo.getSelfValue2())) {
            return false;
        }
        if (com.deepexi.spa.commons.utils.StringUtils.isNotBlank((CharSequence)vo.getSelfValue3())) {
            return false;
        }
        if (com.deepexi.spa.commons.utils.StringUtils.isNotBlank((CharSequence)vo.getSelfValue4())) {
            return false;
        }
        if (com.deepexi.spa.commons.utils.StringUtils.isNotBlank((CharSequence)vo.getEntrustValue1())) {
            return false;
        }
        if (com.deepexi.spa.commons.utils.StringUtils.isNotBlank((CharSequence)vo.getEntrustValue2())) {
            return false;
        }
        if (com.deepexi.spa.commons.utils.StringUtils.isNotBlank((CharSequence)vo.getEntrustValue3())) {
            return false;
        }
        return !com.deepexi.spa.commons.utils.StringUtils.isNotBlank((CharSequence)vo.getEntrustValue4());
    }

    public static class ColumnParam {
        private String alphabet;
        private String name;
        private boolean isAvg;
        private String unit;
        private Integer scale;
        private boolean isRounding;
        private String formula;

        public ColumnParam(String name, String alphabet, boolean isAvg, String unit) {
            this.name = name;
            this.alphabet = alphabet;
            this.isAvg = isAvg;
            this.unit = unit;
            this.isRounding = true;
        }

        public ColumnParam(String name, String alphabet, boolean isAvg, String unit, Integer scale) {
            this.name = name;
            this.alphabet = alphabet;
            this.isAvg = isAvg;
            this.unit = unit;
            this.scale = scale;
            this.isRounding = true;
        }

        public ColumnParam(String name, String alphabet, boolean isAvg, String unit, Integer scale, boolean isRounding) {
            this.name = name;
            this.alphabet = alphabet;
            this.isAvg = isAvg;
            this.unit = unit;
            this.scale = scale;
            this.isRounding = isRounding;
        }

        public ColumnParam(String name, String alphabet, boolean isAvg, String unit, Integer scale, String formula) {
            this.name = name;
            this.alphabet = alphabet;
            this.isAvg = isAvg;
            this.unit = unit;
            this.scale = scale;
            this.formula = formula;
            this.isRounding = true;
        }

        public ColumnParam(String name, String alphabet, boolean isAvg, String unit, Integer scale, boolean isRounding, String formula) {
            this.name = name;
            this.alphabet = alphabet;
            this.isAvg = isAvg;
            this.unit = unit;
            this.scale = scale;
            this.isRounding = isRounding;
            this.formula = formula;
        }

        public ColumnParam(String alphabet, boolean isAvg, String unit, Integer scale) {
            this.alphabet = alphabet;
            this.isAvg = isAvg;
            this.unit = unit;
            this.scale = scale;
            this.isRounding = true;
        }

        public String getAlphabet() {
            return this.alphabet;
        }

        public String getName() {
            return this.name;
        }

        public boolean isAvg() {
            return this.isAvg;
        }

        public String getUnit() {
            return this.unit;
        }

        public Integer getScale() {
            return this.scale;
        }

        public boolean isRounding() {
            return this.isRounding;
        }

        public String getFormula() {
            return this.formula;
        }

        public void setAlphabet(String alphabet) {
            this.alphabet = alphabet;
        }

        public void setName(String name) {
            this.name = name;
        }

        public void setAvg(boolean isAvg) {
            this.isAvg = isAvg;
        }

        public void setUnit(String unit) {
            this.unit = unit;
        }

        public void setScale(Integer scale) {
            this.scale = scale;
        }

        public void setRounding(boolean isRounding) {
            this.isRounding = isRounding;
        }

        public void setFormula(String formula) {
            this.formula = formula;
        }

        public boolean equals(Object o) {
            if (o == this) {
                return true;
            }
            if (!(o instanceof ColumnParam)) {
                return false;
            }
            ColumnParam other = (ColumnParam)o;
            if (!other.canEqual(this)) {
                return false;
            }
            if (this.isAvg() != other.isAvg()) {
                return false;
            }
            if (this.isRounding() != other.isRounding()) {
                return false;
            }
            Integer this$scale = this.getScale();
            Integer other$scale = other.getScale();
            if (this$scale == null ? other$scale != null : !((Object)this$scale).equals(other$scale)) {
                return false;
            }
            String this$alphabet = this.getAlphabet();
            String other$alphabet = other.getAlphabet();
            if (this$alphabet == null ? other$alphabet != null : !this$alphabet.equals(other$alphabet)) {
                return false;
            }
            String this$name = this.getName();
            String other$name = other.getName();
            if (this$name == null ? other$name != null : !this$name.equals(other$name)) {
                return false;
            }
            String this$unit = this.getUnit();
            String other$unit = other.getUnit();
            if (this$unit == null ? other$unit != null : !this$unit.equals(other$unit)) {
                return false;
            }
            String this$formula = this.getFormula();
            String other$formula = other.getFormula();
            return !(this$formula == null ? other$formula != null : !this$formula.equals(other$formula));
        }

        protected boolean canEqual(Object other) {
            return other instanceof ColumnParam;
        }

        public int hashCode() {
            int PRIME = 59;
            int result = 1;
            result = result * 59 + (this.isAvg() ? 79 : 97);
            result = result * 59 + (this.isRounding() ? 79 : 97);
            Integer $scale = this.getScale();
            result = result * 59 + ($scale == null ? 43 : ((Object)$scale).hashCode());
            String $alphabet = this.getAlphabet();
            result = result * 59 + ($alphabet == null ? 43 : $alphabet.hashCode());
            String $name = this.getName();
            result = result * 59 + ($name == null ? 43 : $name.hashCode());
            String $unit = this.getUnit();
            result = result * 59 + ($unit == null ? 43 : $unit.hashCode());
            String $formula = this.getFormula();
            result = result * 59 + ($formula == null ? 43 : $formula.hashCode());
            return result;
        }

        public String toString() {
            return "AbstractTemplateService.ColumnParam(alphabet=" + this.getAlphabet() + ", name=" + this.getName() + ", isAvg=" + this.isAvg() + ", unit=" + this.getUnit() + ", scale=" + this.getScale() + ", isRounding=" + this.isRounding() + ", formula=" + this.getFormula() + ")";
        }
    }
}

